#include <pthread.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

static pthread_mutex_t  mutex = PTHREAD_MUTEX_INITIALIZER;
static int dernier_thread = 0;

void * fonction_thread (void * arg)
{
	int numero = (int) arg;
	struct sched_param param;
	struct timeval tv;

	param.sched_priority = 10;
	if (pthread_setschedparam(pthread_self(), SCHED_RR, & param) != 0) {
		perror("setschedparam");
		exit(EXIT_FAILURE);
	}

	while (1) {
		pthread_mutex_lock(& mutex);
		if (dernier_thread != numero) {
			gettimeofday(& tv, NULL);
			fprintf(stderr, "%ld.%06ld : %d tient le mutex\n", tv.tv_sec, tv.tv_usec, numero);
			dernier_thread = numero;
		}
		pthread_mutex_unlock(& mutex);
	}
	
	return NULL;
}


#define NB_THREADS 5
int main(void)
{
	int i;
	pthread_t thread[NB_THREADS];

	pthread_mutex_lock(& mutex);
	for (i = 0; i < NB_THREADS; i ++) {
		pthread_create(& thread[i], NULL, fonction_thread, (void *) (i+1));
		usleep(10000);
	}
	sleep(1);
	alarm(15);
	fprintf(stderr, "Liberation initiale du mutex\n");
	pthread_mutex_unlock(& mutex);
	for (i = 0; i < NB_THREADS; i ++)
		pthread_join(thread[i], NULL);
	return EXIT_SUCCESS;
}

